unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Grids, Buttons, Spin, ExtDlgs, FileCtrl, IniFiles, Types, fpimage,
  fpreadjpeg, lclintf, ComCtrls, math;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    DrawGrid1: TDrawGrid;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label1: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure DrawGrid1Click(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure DrawGrid1SelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    procedure GridReSize();
    procedure CustomExceptionHandler(Sender: TObject; E: Exception);
    procedure _GetFileList(AStrings: TStrings ; ASourFile: string);
    procedure Clear_buf_image(); //2018/05/21
  public

  end;

var
  Form1: TForm1;
  MyIni: TIniFile;
  DirIni : TIniFile;
  MyPath: String;
  MyList: TStringList;
  MyList2: TStringList; //2018/05/21
  run_once: boolean;
  LastOpenPath: String;
  page_idx: integer;
  left_top_file_id: integer;

  //my_jpg : array[0..100] of TJpegImage;  // 宣告動態物件
  tmp_jpg: TJpegImage;
  myMemImage : TFPMemoryImage; //uses fpimage
  myImgReader: TFPReaderJpeg; //uses fpreadjpeg.pas
  MyImage: TImage;

  stop_draw_pic: integer; //2018/05/21

  buf_image : array[0..20] of TImage; //2018/05/21



implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.CustomExceptionHandler(Sender: TObject; E: Exception);
begin
  ShowMessage(E.Message);
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: integer;
begin
  MyIni := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  MyPath := ExtractFilePath(Application.ExeName);

  MyList := TStringList.Create;
  MyList.Clear;

  //2018/05/21
  MyList2 := TStringList.Create;
  MyList2.Clear;

  tmp_jpg := TJpegImage.Create;
  myMemImage  :=  TFPMemoryImage.create(0, 0);
  myImgReader := TFPReaderJPEG.Create;
  MyImage := TImage.Create(self);

  for i:=0 to 20 do begin
      buf_image[i]:= TImage.Create(self);
  end;




  run_once:=false;

  left_top_file_id:=0;

  stop_draw_pic:=0; //2018/05/21

  Application.OnException := @CustomExceptionHandler;

end;

procedure TForm1.FormActivate(Sender: TObject);
var i: integer;
    ii: integer;
begin
  if (run_once) then exit;

  run_once:=true;

  LastOpenPath:=MyIni.ReadString('PARAMETER', 'LastOpenPath', MyPath);

  SpinEdit1.Value:=MyIni.ReadInteger('PARAMETER', 'SpinEdit1_Value', SpinEdit1.MinValue);
  SpinEdit2.Value:=MyIni.ReadInteger('PARAMETER', 'SpinEdit2_Value', SpinEdit2.MinValue);

  if DirectoryExists(LastOpenPath) then begin
      _GetFileList(MyList, LastOpenPath+'\*.JPG');

      {
      //處理選擇參數之 ini
      if (DirIni<>nil) then begin
          FreeAndNil(DirIni);
      end;
      DirIni := TIniFile.Create(MyPath+'\'+ExtractFileName(LastOpenPath)+'.ini');
      Edit1.Text:=DirIni.ReadString('PARAMETER', 'SELECT_01_NAME', '分類名稱可修改_01');
      Edit2.Text:=DirIni.ReadString('PARAMETER', 'SELECT_02_NAME', '分類名稱可修改_02');
      Edit3.Text:=DirIni.ReadString('PARAMETER', 'SELECT_03_NAME', '分類名稱可修改_03');
      Edit4.Text:=DirIni.ReadString('PARAMETER', 'SELECT_04_NAME', '分類名稱可修改_04');
      Edit5.Text:=DirIni.ReadString('PARAMETER', 'SELECT_05_NAME', '分類名稱可修改_05');
      Edit6.Text:=DirIni.ReadString('PARAMETER', 'SELECT_06_NAME', '分類名稱可修改_06');
      DirIni.WriteString('PARAMETER', 'SELECT_01_NAME', Edit1.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_02_NAME', Edit2.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_03_NAME', Edit3.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_04_NAME', Edit4.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_05_NAME', Edit5.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_06_NAME', Edit6.Text);
      for i:=0 to MyList.Count-1 do begin
          DirIni.WriteBool('SELECT_01', FormatFloat('0000', i), DirIni.ReadBool('SELECT_01', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_02', FormatFloat('0000', i), DirIni.ReadBool('SELECT_02', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_03', FormatFloat('0000', i), DirIni.ReadBool('SELECT_03', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_04', FormatFloat('0000', i), DirIni.ReadBool('SELECT_04', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_05', FormatFloat('0000', i), DirIni.ReadBool('SELECT_05', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_06', FormatFloat('0000', i), DirIni.ReadBool('SELECT_06', FormatFloat('0000', i), false));
      end;
      }

      //2018/05/21 ->
      if (FileExists(LastOpenPath+'\SELECT.TXT')) then begin
          MyList2.LoadFromFile(LastOpenPath+'\SELECT.TXT');
          Edit1.Text:=MyList2.Values['SELECT_01_NAME'];
          Edit2.Text:=MyList2.Values['SELECT_02_NAME'];
          Edit3.Text:=MyList2.Values['SELECT_03_NAME'];
          Edit4.Text:=MyList2.Values['SELECT_04_NAME'];
          Edit5.Text:=MyList2.Values['SELECT_05_NAME'];
          Edit6.Text:=MyList2.Values['SELECT_06_NAME'];
      end else begin
          Edit1.Text:='分類名稱可修改_01';
          Edit2.Text:='分類名稱可修改_02';
          Edit3.Text:='分類名稱可修改_03';
          Edit4.Text:='分類名稱可修改_04';
          Edit5.Text:='分類名稱可修改_05';
          Edit6.Text:='分類名稱可修改_06';
      end;
      MyList2.Values['SELECT_01_NAME']:=Edit1.Text;
      MyList2.Values['SELECT_02_NAME']:=Edit2.Text;
      MyList2.Values['SELECT_03_NAME']:=Edit3.Text;
      MyList2.Values['SELECT_04_NAME']:=Edit4.Text;
      MyList2.Values['SELECT_05_NAME']:=Edit5.Text;
      MyList2.Values['SELECT_06_NAME']:=Edit6.Text;
      //2018/05/21 <-


      Form1.Caption:='JPG 照片挑選器 - '+LastOpenPath + ' ('+IntToStr(MyList.Count)+' 張照片)';
      left_top_file_id:=0;
      Label1.Caption:='頁次 1 / '+IntToStr(Ceil(MyList.Count/(SpinEdit1.Value*SpinEdit2.Value))); //2018/05/21
      Clear_buf_image(); //2018/05/21
      DrawGrid1.Refresh;
      DrawGrid1.SetFocus;
      DrawGrid1Click(self);
  end;


  GridReSize();
end;

//開啟來源目錄
procedure TForm1.BitBtn1Click(Sender: TObject);
var i: integer;
    old_LastOpenPath: String; //2018/05/21
begin

  old_LastOpenPath:=LastOpenPath; //2018/05/21

  SelectDirectoryDialog1.InitialDir:=ExtractFilePath(LastOpenPath);
  if SelectDirectoryDialog1.Execute then begin
      LastOpenPath:=SelectDirectoryDialog1.FileName ;
      _GetFileList(MyList, LastOpenPath+'\*.JPG');

      {
      //處理選擇參數之 ini
      if (DirIni<>nil) then begin
          FreeAndNil(DirIni);
      end;
      DirIni := TIniFile.Create(MyPath+'\'+ExtractFileName(LastOpenPath)+'.ini');
      Edit1.Text:=DirIni.ReadString('PARAMETER', 'SELECT_01_NAME', '分類名稱可修改_01');
      Edit2.Text:=DirIni.ReadString('PARAMETER', 'SELECT_02_NAME', '分類名稱可修改_02');
      Edit3.Text:=DirIni.ReadString('PARAMETER', 'SELECT_03_NAME', '分類名稱可修改_03');
      Edit4.Text:=DirIni.ReadString('PARAMETER', 'SELECT_04_NAME', '分類名稱可修改_04');
      Edit5.Text:=DirIni.ReadString('PARAMETER', 'SELECT_05_NAME', '分類名稱可修改_05');
      Edit6.Text:=DirIni.ReadString('PARAMETER', 'SELECT_06_NAME', '分類名稱可修改_06');
      DirIni.WriteString('PARAMETER', 'SELECT_01_NAME', Edit1.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_02_NAME', Edit2.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_03_NAME', Edit3.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_04_NAME', Edit4.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_05_NAME', Edit5.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_06_NAME', Edit6.Text);
      for i:=0 to MyList.Count-1 do begin
          DirIni.WriteBool('SELECT_01', FormatFloat('0000', i), DirIni.ReadBool('SELECT_01', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_02', FormatFloat('0000', i), DirIni.ReadBool('SELECT_02', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_03', FormatFloat('0000', i), DirIni.ReadBool('SELECT_03', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_04', FormatFloat('0000', i), DirIni.ReadBool('SELECT_04', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_05', FormatFloat('0000', i), DirIni.ReadBool('SELECT_05', FormatFloat('0000', i), false));
          DirIni.WriteBool('SELECT_06', FormatFloat('0000', i), DirIni.ReadBool('SELECT_06', FormatFloat('0000', i), false));
      end;
      }

      //2018/05/21 ->
      if (FileExists(old_LastOpenPath+'\SELECT.TXT')) then begin
          MyList2.Values['SELECT_01_NAME']:=Edit1.Text;
          MyList2.Values['SELECT_02_NAME']:=Edit2.Text;
          MyList2.Values['SELECT_03_NAME']:=Edit3.Text;
          MyList2.Values['SELECT_04_NAME']:=Edit4.Text;
          MyList2.Values['SELECT_05_NAME']:=Edit5.Text;
          MyList2.Values['SELECT_06_NAME']:=Edit6.Text;
          MyList2.SaveToFile(old_LastOpenPath+'\SELECT.TXT');
      end;
      if (FileExists(LastOpenPath+'\SELECT.TXT')) then begin
          MyList2.LoadFromFile(LastOpenPath+'\SELECT.TXT');
          Edit1.Text:=MyList2.Values['SELECT_01_NAME'];
          Edit2.Text:=MyList2.Values['SELECT_02_NAME'];
          Edit3.Text:=MyList2.Values['SELECT_03_NAME'];
          Edit4.Text:=MyList2.Values['SELECT_04_NAME'];
          Edit5.Text:=MyList2.Values['SELECT_05_NAME'];
          Edit6.Text:=MyList2.Values['SELECT_06_NAME'];
      end else begin
          Edit1.Text:='分類名稱可修改_01';
          Edit2.Text:='分類名稱可修改_02';
          Edit3.Text:='分類名稱可修改_03';
          Edit4.Text:='分類名稱可修改_04';
          Edit5.Text:='分類名稱可修改_05';
          Edit6.Text:='分類名稱可修改_06';
      end;
      MyList2.Values['SELECT_01_NAME']:=Edit1.Text;
      MyList2.Values['SELECT_02_NAME']:=Edit2.Text;
      MyList2.Values['SELECT_03_NAME']:=Edit3.Text;
      MyList2.Values['SELECT_04_NAME']:=Edit4.Text;
      MyList2.Values['SELECT_05_NAME']:=Edit5.Text;
      MyList2.Values['SELECT_06_NAME']:=Edit6.Text;
      //2018/05/21 <-


      Form1.Caption:='JPG 照片挑選器 - '+LastOpenPath + ' ('+IntToStr(MyList.Count)+' 張照片)';
      left_top_file_id:=0;
      Label1.Caption:='頁次 1 / '+IntToStr(Ceil(MyList.Count/(SpinEdit1.Value*SpinEdit2.Value))); //2018/05/21
      Clear_buf_image(); //2018/05/21
      DrawGrid1.Refresh;
      DrawGrid1.SetFocus;
      DrawGrid1Click(self);
  end;
end;

//上頁
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  TBitBtn(Sender).Enabled:=false;
  if (left_top_file_id-(SpinEdit1.Value*SpinEdit2.Value)>=0) then begin
      left_top_file_id:=left_top_file_id-(SpinEdit1.Value*SpinEdit2.Value);

      //2018/05/21
      Label1.Caption:='頁次 '+
      IntToStr(Trunc(left_top_file_id/(SpinEdit1.Value*SpinEdit2.Value)+1))
      +' / '+
      IntToStr(Ceil(MyList.Count/(SpinEdit1.Value*SpinEdit2.Value)));

      Clear_buf_image(); //2018/05/21

      DrawGrid1.Refresh;
      //DrawGrid1.SetFocus;
      DrawGrid1Click(self);
  end;
  TBitBtn(Sender).Enabled:=true;
end;

//下頁
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  TBitBtn(Sender).Enabled:=false;
  if (left_top_file_id+(SpinEdit1.Value*SpinEdit2.Value)<=MyList.Count-1) then begin
      left_top_file_id:=left_top_file_id+(SpinEdit1.Value*SpinEdit2.Value);

      //2018/05/21
      Label1.Caption:='頁次 '+
      IntToStr(Trunc(left_top_file_id/(SpinEdit1.Value*SpinEdit2.Value)+1))
      +' / '+
      IntToStr(Ceil(MyList.Count/(SpinEdit1.Value*SpinEdit2.Value)));

      Clear_buf_image(); //2018/05/21

      DrawGrid1.Refresh;
      //DrawGrid1.SetFocus;
      DrawGrid1Click(self);
  end;
  TBitBtn(Sender).Enabled:=true;
end;

//複製 JPG 到新分類目錄中
procedure TForm1.BitBtn4Click(Sender: TObject);
var new_dir: String;
    new_dir1: String;
    new_dir2: String;
    new_dir3: String;
    new_dir4: String;
    new_dir5: String;
    new_dir6: String;
    i: integer;
    tmp: String; //2018/05/21
begin
  if (MyList.Count=0) then begin
      ShowMessage('沒有檔案可複製');
      exit;
  end;

  new_dir:='C:\照片分類\'+ExtractFileName(LastOpenPath)+'(分類)'+FormatDateTime('_yyyymmddhhnnss', Now);
  ForceDirectories(new_dir);

  new_dir1:=new_dir+'\'+Edit1.Text;
  ForceDirectories(new_dir1);

  new_dir2:=new_dir+'\'+Edit2.Text;
  ForceDirectories(new_dir2);

  new_dir3:=new_dir+'\'+Edit3.Text;
  ForceDirectories(new_dir3);

  new_dir4:=new_dir+'\'+Edit4.Text;
  ForceDirectories(new_dir4);

  new_dir5:=new_dir+'\'+Edit5.Text;
  ForceDirectories(new_dir5);

  new_dir6:=new_dir+'\'+Edit6.Text;
  ForceDirectories(new_dir6);

  {
  for i:=0 to MyList.Count-1 do begin
      if (DirIni.ReadBool('SELECT_01', FormatFloat('0000', i), false)=true) then begin
          CopyFile(MyList.Strings[i], new_dir1+'\'+ExtractFileName(MyList.Strings[i]));
      end;
      if (DirIni.ReadBool('SELECT_02', FormatFloat('0000', i), false)=true) then begin
          CopyFile(MyList.Strings[i], new_dir2+'\'+ExtractFileName(MyList.Strings[i]));
      end;
      if (DirIni.ReadBool('SELECT_03', FormatFloat('0000', i), false)=true) then begin
          CopyFile(MyList.Strings[i], new_dir3+'\'+ExtractFileName(MyList.Strings[i]));
      end;
      if (DirIni.ReadBool('SELECT_04', FormatFloat('0000', i), false)=true) then begin
          CopyFile(MyList.Strings[i], new_dir4+'\'+ExtractFileName(MyList.Strings[i]));
      end;
      if (DirIni.ReadBool('SELECT_05', FormatFloat('0000', i), false)=true) then begin
          CopyFile(MyList.Strings[i], new_dir5+'\'+ExtractFileName(MyList.Strings[i]));
      end;
      if (DirIni.ReadBool('SELECT_06', FormatFloat('0000', i), false)=true) then begin
          CopyFile(MyList.Strings[i], new_dir6+'\'+ExtractFileName(MyList.Strings[i]));
      end;
  end;
  }


  //2018/05/21 ->
  for i:=0 to MyList.Count-1 do begin
      tmp:=MyList2.Values[FormatFloat('0000', i)];
      if tmp='' then tmp:='0000000000';
      if tmp[1]='1' then CopyFile(MyList.Strings[i], new_dir1+'\'+ExtractFileName(MyList.Strings[i]));
      if tmp[2]='1' then CopyFile(MyList.Strings[i], new_dir2+'\'+ExtractFileName(MyList.Strings[i]));
      if tmp[3]='1' then CopyFile(MyList.Strings[i], new_dir3+'\'+ExtractFileName(MyList.Strings[i]));
      if tmp[4]='1' then CopyFile(MyList.Strings[i], new_dir4+'\'+ExtractFileName(MyList.Strings[i]));
      if tmp[5]='1' then CopyFile(MyList.Strings[i], new_dir5+'\'+ExtractFileName(MyList.Strings[i]));
      if tmp[6]='1' then CopyFile(MyList.Strings[i], new_dir6+'\'+ExtractFileName(MyList.Strings[i]));

  end;
  //2018/05/21 <-



  ShowMessage('檔案分類拷貝完成');

  OpenDocument(new_dir);


end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var cell_file_id: integer;
    tmp: String; //2018/05/21
begin
  cell_file_id:=left_top_file_id + DrawGrid1.Row*DrawGrid1.ColCount+DrawGrid1.Col;

  //DirIni.WriteBool('SELECT_01', FormatFloat('0000', cell_file_id), CheckBox1.Checked);

  //2018/05/21 ->
  tmp:=MyList2.Values[FormatFloat('0000', cell_file_id)];
  if tmp='' then tmp:='0000000000';
  if (CheckBox1.Checked) then begin
      tmp[1]:='1';
  end else begin
      tmp[1]:='0';
  end;
  MyList2.Values[FormatFloat('0000', cell_file_id)]:=tmp;
  //2018/05/21 <-

end;

procedure TForm1.CheckBox2Click(Sender: TObject);
var cell_file_id: integer;
    tmp: String; //2018/05/21
begin
  cell_file_id:=left_top_file_id + DrawGrid1.Row*DrawGrid1.ColCount+DrawGrid1.Col;
  //DirIni.WriteBool('SELECT_02', FormatFloat('0000', cell_file_id), CheckBox2.Checked);

  //2018/05/21 ->
  tmp:=MyList2.Values[FormatFloat('0000', cell_file_id)];
  if tmp='' then tmp:='0000000000';
  if (CheckBox2.Checked) then begin
      tmp[2]:='1';
  end else begin
      tmp[2]:='0';
  end;
  MyList2.Values[FormatFloat('0000', cell_file_id)]:=tmp;
  //2018/05/21 <-

end;

procedure TForm1.CheckBox3Click(Sender: TObject);
var cell_file_id: integer;
    tmp: String; //2018/05/21
begin
  cell_file_id:=left_top_file_id + DrawGrid1.Row*DrawGrid1.ColCount+DrawGrid1.Col;
  //DirIni.WriteBool('SELECT_03', FormatFloat('0000', cell_file_id), CheckBox3.Checked);

  //2018/05/21 ->
  tmp:=MyList2.Values[FormatFloat('0000', cell_file_id)];
  if tmp='' then tmp:='0000000000';
  if (CheckBox3.Checked) then begin
      tmp[3]:='1';
  end else begin
      tmp[3]:='0';
  end;
  MyList2.Values[FormatFloat('0000', cell_file_id)]:=tmp;
  //2018/05/21 <-

end;

procedure TForm1.CheckBox4Click(Sender: TObject);
var cell_file_id: integer;
    tmp: String; //2018/05/21
begin
  cell_file_id:=left_top_file_id + DrawGrid1.Row*DrawGrid1.ColCount+DrawGrid1.Col;
  //DirIni.WriteBool('SELECT_04', FormatFloat('0000', cell_file_id), CheckBox4.Checked);

  //2018/05/21 ->
  tmp:=MyList2.Values[FormatFloat('0000', cell_file_id)];
  if tmp='' then tmp:='0000000000';
  if (CheckBox4.Checked) then begin
      tmp[4]:='1';
  end else begin
      tmp[4]:='0';
  end;
  MyList2.Values[FormatFloat('0000', cell_file_id)]:=tmp;
  //2018/05/21 <-

end;

procedure TForm1.CheckBox5Click(Sender: TObject);
var cell_file_id: integer;
    tmp: String; //2018/05/21
begin
  cell_file_id:=left_top_file_id + DrawGrid1.Row*DrawGrid1.ColCount+DrawGrid1.Col;
  //DirIni.WriteBool('SELECT_05', FormatFloat('0000', cell_file_id), CheckBox5.Checked);

  //2018/05/21 ->
  tmp:=MyList2.Values[FormatFloat('0000', cell_file_id)];
  if tmp='' then tmp:='0000000000';
  if (CheckBox5.Checked) then begin
      tmp[5]:='1';
  end else begin
      tmp[5]:='0';
  end;
  MyList2.Values[FormatFloat('0000', cell_file_id)]:=tmp;
  //2018/05/21 <-

end;

procedure TForm1.CheckBox6Click(Sender: TObject);
var cell_file_id: integer;
    tmp: String; //2018/05/21
begin
  cell_file_id:=left_top_file_id + DrawGrid1.Row*DrawGrid1.ColCount+DrawGrid1.Col;
  //DirIni.WriteBool('SELECT_06', FormatFloat('0000', cell_file_id), CheckBox6.Checked);

  //2018/05/21 ->
  tmp:=MyList2.Values[FormatFloat('0000', cell_file_id)];
  if tmp='' then tmp:='0000000000';
  if (CheckBox6.Checked) then begin
      tmp[6]:='1';
  end else begin
      tmp[6]:='0';
  end;
  MyList2.Values[FormatFloat('0000', cell_file_id)]:=tmp;
  //2018/05/21 <-

end;

procedure TForm1.DrawGrid1Click(Sender: TObject);
var cell_file_id: integer;
    tmp: String; //2018/05/21
begin
  cell_file_id:=left_top_file_id + DrawGrid1.Row*DrawGrid1.ColCount+DrawGrid1.Col;
  if (cell_file_id>=0) and (cell_file_id<=MyList.Count-1) then begin
      {
      CheckBox1.Checked:=DirIni.ReadBool('SELECT_01', FormatFloat('0000', cell_file_id), false);
      CheckBox2.Checked:=DirIni.ReadBool('SELECT_02', FormatFloat('0000', cell_file_id), false);
      CheckBox3.Checked:=DirIni.ReadBool('SELECT_03', FormatFloat('0000', cell_file_id), false);
      CheckBox4.Checked:=DirIni.ReadBool('SELECT_04', FormatFloat('0000', cell_file_id), false);
      CheckBox5.Checked:=DirIni.ReadBool('SELECT_05', FormatFloat('0000', cell_file_id), false);
      CheckBox6.Checked:=DirIni.ReadBool('SELECT_06', FormatFloat('0000', cell_file_id), false);
      }

      //2018/05/21 ->
      tmp:=MyList2.Values[FormatFloat('0000', cell_file_id)];
      if tmp='' then tmp:='0000000000';
      if (tmp[1]='1') then CheckBox1.Checked:=true else CheckBox1.Checked:=false;
      if (tmp[2]='1') then CheckBox2.Checked:=true else CheckBox2.Checked:=false;
      if (tmp[3]='1') then CheckBox3.Checked:=true else CheckBox3.Checked:=false;
      if (tmp[4]='1') then CheckBox4.Checked:=true else CheckBox4.Checked:=false;
      if (tmp[5]='1') then CheckBox5.Checked:=true else CheckBox5.Checked:=false;
      if (tmp[6]='1') then CheckBox6.Checked:=true else CheckBox6.Checked:=false;
      //2018/05/21 <-


  end;
end;

procedure TForm1.DrawGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var cell_file_id: integer;
    disp_str: String;
    in_page_file_id: integer; //2018/05/21
begin

  cell_file_id:=left_top_file_id + aRow*TDrawGrid(Sender).ColCount+aCol;
  in_page_file_id:=aRow*TDrawGrid(Sender).ColCount+aCol; //2018/05/21

  disp_str:=FormatFloat('0000', cell_file_id);





  if (cell_file_id>=0) and (cell_file_id<=MyList.Count-1) then begin
      disp_str:=disp_str+'_'+ExtractFileName(MyList.Strings[cell_file_id]);

      MyMemImage.UsePalette := false;
      MyMemImage.Width:=aRect.Width;
      MyMemImage.Height:=aRect.Height;

      MyImgReader.Scale:= jsQuarter;  //jsEighth, jsQuarter, jsHalf, jsFullSize
      MyImgReader.Performance:=jpBestSpeed;

      {
      MyMemImage.LoadFromFile(MyList.Strings[cell_file_id], myImgReader);
      MyImage.Stretch:=true;
      MyImage.Picture.Assign(myMemImage);
      TDrawGrid(Sender).Canvas.Draw(aRect.Left, aRect.Top, MyImage.Picture.Graphic);
      }

      //2018/05/21 加快顯示速度
      if (buf_image[in_page_file_id].Picture.Width=0) then begin //用此方法判斷 nil , 用 ...picture=nil 無效
          MyMemImage.LoadFromFile(MyList.Strings[cell_file_id], myImgReader);
          buf_image[in_page_file_id].Width:=aRect.Width;
          buf_image[in_page_file_id].Height:=aRect.Height;
          buf_image[in_page_file_id].Stretch:=true;
          buf_image[in_page_file_id].Picture.Assign(myMemImage);
      end;
      TDrawGrid(Sender).Canvas.Draw(aRect.Left, aRect.Top, buf_image[in_page_file_id].Picture.Graphic);



  end;





  if (aCol=TDrawGrid(Sender).Col) and (aRow=TDrawGrid(Sender).Row) then begin
      TDrawGrid(Sender).Canvas.Pen.Mode:=pmMask;
      TDrawGrid(Sender).Canvas.Pen.color:=clred; //clFuchsia; //clred;
      TDrawGrid(Sender).Canvas.Pen.Width:=10;
      TDrawGrid(Sender).Canvas.Rectangle(aRect);
  end;


  //DrawText(TDrawGrid(Sender).Canvas.Handle, pchar(disp_str),
  //            Length(disp_str), aRect, DT_CENTER);


  TDrawGrid(Sender).Font.Size:=12;
  TDrawGrid(Sender).Canvas.TextRect (aRect, aRect.Left+5, aRect.Top+5, disp_str); //無法置中,置右

end;

procedure TForm1.DrawGrid1SelectCell(Sender: TObject; aCol, aRow: Integer;
  var CanSelect: Boolean);
var cell_file_id: integer;
begin
  {
  cell_file_id:=left_top_file_id + aRow*TDrawGrid(Sender).ColCount+aCol;
  if (cell_file_id>=0) and (cell_file_id<=MyList.Count-1) then begin
      CheckBox1.Checked:=DirIni.ReadBool('SELECT_01', FormatFloat('0000', cell_file_id), false);
      CheckBox2.Checked:=DirIni.ReadBool('SELECT_02', FormatFloat('0000', cell_file_id), false);
      CheckBox3.Checked:=DirIni.ReadBool('SELECT_03', FormatFloat('0000', cell_file_id), false);
      CheckBox4.Checked:=DirIni.ReadBool('SELECT_04', FormatFloat('0000', cell_file_id), false);
      CheckBox5.Checked:=DirIni.ReadBool('SELECT_05', FormatFloat('0000', cell_file_id), false);
      CheckBox6.Checked:=DirIni.ReadBool('SELECT_06', FormatFloat('0000', cell_file_id), false);
  end;
  }
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var i: integer;
begin

  MyIni.WriteString('PARAMETER', 'LastOpenPath', LastOpenPath);
  MyIni.WriteInteger('PARAMETER', 'SpinEdit1_Value', SpinEdit1.Value);
  MyIni.WriteInteger('PARAMETER', 'SpinEdit2_Value', SpinEdit2.Value);


  //2018/05/21 ->
  if (DirectoryExists(LastOpenPath)) then begin
      if (MyList2.Count>0) then begin
          MyList2.Values['SELECT_01_NAME']:=Edit1.Text;
          MyList2.Values['SELECT_02_NAME']:=Edit2.Text;
          MyList2.Values['SELECT_03_NAME']:=Edit3.Text;
          MyList2.Values['SELECT_04_NAME']:=Edit4.Text;
          MyList2.Values['SELECT_05_NAME']:=Edit5.Text;
          MyList2.Values['SELECT_06_NAME']:=Edit6.Text;
          MyList2.SaveToFile(LastOpenPath+'\SELECT.TXT');
      end;
  end;
  //2018/05/21 <-



  for i:=0 to 20 do begin
      FreeAndNil(buf_image[i]);
  end;



  tmp_jpg.Free;
  myMemImage.Free;
  myImgReader.Free;
  MyImage.Free;

  MyList.Free;
  MyList2.Free;//2018/05/21
  MyIni.Free;

  {
  if (DirIni<>nil) then begin
      DirIni.WriteString('PARAMETER', 'SELECT_01_NAME', Edit1.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_02_NAME', Edit2.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_03_NAME', Edit3.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_04_NAME', Edit4.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_05_NAME', Edit5.Text);
      DirIni.WriteString('PARAMETER', 'SELECT_06_NAME', Edit6.Text);
      FreeAndNil(DirIni);
  end;
  }

end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  GridReSize();
end;

procedure TForm1.FormWindowStateChange(Sender: TObject);
begin
  GridReSize();
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  GridReSize();
end;

procedure TForm1.GridReSize();
var x, y: integer;
begin
  x:=SpinEdit1.Value;
  y:=SpinEdit2.Value;

  DrawGrid1.ColCount:=x;
  DrawGrid1.RowCount:=y;

  DrawGrid1.DefaultColWidth:=Trunc(DrawGrid1.Width/DrawGrid1.ColCount);
  DrawGrid1.DefaultRowHeight:=Trunc(DrawGrid1.Height/DrawGrid1.RowCount);

  //MyIni.WriteInteger('PARAMETER', 'SpinEdit1_Value', SpinEdit1.Value);
  //MyIni.WriteInteger('PARAMETER', 'SpinEdit2_Value', SpinEdit2.Value);
  //MyIni.UpdateFile;

  //DrawGrid1.SetFocus;

end;

//2018/05/21
procedure TForm1.Clear_buf_image();
var i: integer;
begin
  for i:=0 to 20 do begin
      //buf_image[i].Picture.Clear;
      buf_image[i].Picture := nil;
  end;
end;

//---------------------------------------------------------------------------
// 函數名稱：_GetFileList
// 中文說明：取得目錄中的檔案 List
// 傳 回 值：
// 參    數：
// 機能說明：_GetFileList(ListBox1.Items,'c:\*.doc');
//           _GetFileList(MyTStringList,'c:\*.exe');
//---------------------------------------------------------------------------
procedure TForm1._GetFileList(AStrings: TStrings ; ASourFile: string);
var sour_path,sour_file: string;
    TmpList:TStringList;
    FileRec:TSearchrec;
begin

   sour_path:=ExtractFilePath(ASourFile);
   sour_file:=ExtractFileName(ASourFile);

   //if not DirectoryExists(utf8toansi(sour_path)) then  //2010/09/15 加入 utf8toansi()
   if not DirectoryExists(sour_path) then
   begin
     AStrings.Clear;
     exit;
   end;

   TmpList:=TStringList.Create;
   TmpList.Clear;

   //if FindFirst(utf8toansi(sour_path+sour_file),faAnyfile,FileRec) = 0 then //2010/09/15 加入 utf8toansi()
   if FindFirst(sour_path+sour_file,faAnyfile,FileRec) = 0 then
   repeat
      if ((FileRec.Attr and faDirectory) = 0) then
         begin
           TmpList.Add(sour_path+FileRec.Name);
           //TmpList.Add(sour_path+AnsiToUtf8(FileRec.Name)); //2011/01/12
           //TmpList.Add(AnsiToUtf8(sour_path+FileRec.Name)); //2018/05/20
         end;
   until FindNext(FileRec)<>0;

   SysUtils.FindClose(FileRec);

   TmpList.Sort;
   AStrings.Assign(TmpList);

   TmpList.Free;
end;


end.

